module Sheriff

  class << self
    @@defined_feature_sets = []

    def defined_feature_sets
      @@defined_feature_sets
    end
  end

  module ClassMethods

    def defined_feature_sets
      Sheriff.defined_feature_sets
    end

  end

  def self.included(base)
    base.extend ClassMethods
  end

  def FeatureSet(feature_set_name)
    FeatureSet.find feature_set_name
  end

  def feature_set(feature_set_name)
    context = self

    fs = FeatureSet.find(feature_set_name).dup
    fs.context = context
    fs
  end
end

include Sheriff
